SD_DATA_PORT EQU 0f000h
SD_CONF_PORT EQU 0f001h
;SDTYPE EQU 007fh

CMD0   EQU 040h ; resets the card
CMD8   EQU 048h ; read IF_COND
CMD9   EQU 049h ; read CSD
CMD16  EQU 050h ; set R/W block
CMD17  EQU 051h ; read block
CMD24  EQU 058h ; write block
CMD55  EQU 077h ; next command is ACMDxx
CMD58  EQU 07ah ;
ACMD41 EQU 069h ; send host capacity support, init card

SD_ON:    ld a,01h
      jp SD_CONF
SD_OFF:   ld a,00h
SD_CONF:
      ld    (SD_CONF_PORT),a
      ret
SD_FIN:   ld    A,0FFh
SD_PUT:   ld    (SD_DATA_PORT),a
          ret

SD_GET:   CALL SD_FIN
      ld a,(SD_DATA_PORT)
      ret 

SD_CMD:   ld    hl,0
SD_CMDW:  ld    de,0
SD_CMDD:  call  SD_FIN
      ld    A,C
      push af
      call  SD_PUT
      ld    A,D
      call  SD_PUT
      ld    A,E
      call  SD_PUT
      ld    A,H
      call  SD_PUT
      ld    A,L
      call  SD_PUT
      pop af
      cp CMD8
      ld    A,87h
      jr  z,putCRC
      ld    A,95h
putCRC:
      call  SD_PUT
      ld    de,8080h
  
SD_WAIT:  ld    hl,20000
SDW_L1:   call  SD_GET
      ld    C,A
      sub   D 
      cp    E 
      ld    A,C
      ret   nc  
      dec   hl  
      ld    A,H
      or    L 
      jp    nz,SDW_L1
      sub   1 
      ret 

SD_INIT:  call  SD_OFF
      ld    B,10h
      call  SD_FIN
      dec   B 
      jp    nz,$-4
      call  SD_ON
      ld    C,CMD0
      call  SD_CMD
      cp    1 
      ret   nz  
;      ld  hl,01AAh
;      ld  C,CMD8
;      call SD_CMDW
;      cp 01h
;      jp z,SD_V2
SD_V1:
      ld C,041h
      call SD_CMD
      and   0FEh
      ret  nz
      ld  C,041h
      call SD_CMD
      cp 1
      jp z,SD_V1
;=============================================
;  ld A,00h
;  ld (SDTYPE),a
;=============================================
     ret
;SD_V2:
;  call SD_GET  ;read cmd8 answer
;  call SD_GET
;  call SD_GET
;  call SD_GET
;  cp 0AAh
;  jp nz,SD_V1 ;if here, answer must be (0x01,0x00,0x00,0x01,0xAA) if not check SD_V1
;SDI_L1:
;  ld C,CMD55
;  call SD_CMD
;  and   0FEh
;  ret   nz
;  ld hl,0000h
;  ld de,4000h
;  ld C,ACMD41
;  call SD_CMDD
;  cp  1
;  jp    z,SDI_L1
;  ld C,CMD58
;  call SD_CMD
;  call SD_GET
;  and 040h
;  jp  nz,SD_V2P
;=============================================
;  ld A,01h
;  ld (SDTYPE),a
;=============================================
;  call SD_GET
;  call SD_GET
;  call SD_GET
;SD_V2M:
;  ld hl,0200h
;  ld C,CMD16
;  call SD_CMDW
;  ret
;SD_V2P:
;  call SD_GET
;  call SD_GET
;  call SD_GET
;=============================================
;  ld A,0ffh
;  ld (SDTYPE),a
;=============================================
;  ld hl,0200h
;  ld C,CMD16
;  call SD_CMDW
;  ret

POPHRET:  
      pop   hl  
      ret 

SD_RWR:
      push  de
      push  bc
      ld    de,0FFh
      call  SD_WAIT
      pop   bc  
      pop   hl  
      ret c 
;      ld a,(SDTYPE)
;      cp 0ffh
;      jr nz,SD_RWR0
;      ld E,0h
;      ld D,0h ;SDHC...
;      scf
;      ccf
;      ret
;SD_RWR0:
      ld    A,0h
      add   hl,hl
      adc   A,A
      ld    D,A
      ld    E,H
      ld    H,L
      ld    L,0
      ret

SD_READ:
      push  hl
      call SD_RWR
      jp    c,POPHRET
      ld    C,CMD17
      call  SD_CMDD
      jp    c,POPHRET
      ld    de,0FF01h
      call  SD_WAIT
      pop   hl  
      cp    0FEh
      ret   nz  
      ld    B,0
SDR_L1:   call  SD_GET
      ld    (hl),A
      inc   hl  
      call  SD_GET
      ld    (hl),A
      inc   hl  
      dec   B 
      jp    nz,SDR_L1
    call  SD_GET 
    call  SD_GET 
  ret

SD_WRITE:
      push  hl
      call SD_RWR
      jp    c,POPHRET
      ld    C,CMD24
      call  SD_CMDD
      jp    c,POPHRET
      pop  hl
      ld a,0feh
      call SD_PUT
      ld B,0h
SDR_WL1:
      ld A,(hl)
      inc hl
      call SD_PUT
      ld A,(hl)
      inc hl
      call SD_PUT
      dec B
      jp    nz,SDR_WL1
    call SD_FIN
    call SD_FIN
  ret

